<?php

//////////
///
///   auth.inc.php
///
//////////
///
///   auth_login($user, $pass)
///   auth_ping()
///   auth_logout()
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if(!$al) {
   $dm['auth.login']['function'] = 'auth_login';
//   $dm['auth.login']['signature'] = array(array($xmlrpcStruct,     // return value
//                                                $xmlrpcString,     // $user
//                                                $xmlrpcString));   // $pass
}

if($al) {
   $dm['auth.ping']['function'] = 'auth_ping';
//   $dm['auth.ping']['signature'] = array(array($xmlrpcBoolean));   // return value
}

if($al) {
   $dm['auth.logout']['function'] = 'auth_logout';
//   $dm['auth.logout']['signature'] = array(array($xmlrpcBoolean));   // return value
}

if($al) {
   $dm['auth.setsession']['function'] = 'auth_setsession';
//   $dm['auth.setsession']['signature'] = array(array($xmlrpcBoolean));   // return value
}



/***************\
*   FUNCTIONS   *
\***************/

function auth_login($user, $pass)
{
   $ret = db_escape(array(&$user,
                          &$pass));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `user_id`, ";
   $sql .=        "`user`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_auth']['failed'];
   }

   settype($ret[0]->level, 'int');

   $_SESSION['authuserid'] = $ret[0]->user_id;
   $_SESSION['authuser'] = $ret[0]->user;
   $_SESSION['authlevel'] = $ret[0]->level;
   $_SESSION['authmaxlog'] = 0;

   unset($ret[0]->user_id);
   unset($ret[0]->user);

   return $ret[0];
}

function auth_ping()
{
   return true;
}

function auth_logout()
{
   return session_destroy();
}

function auth_setsession()
{
   $sql  = "SELECT MAX(`log_id`) AS `maxlog`";
   $sql .= "FROM `log`";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   }

   $_SESSION['authmaxlog'] = (integer)$ret[0]->maxlog;
   
   return true;
}

?>
