;NSIS Modern User Interface

;--------------------------------
;Include Modern UI

  !include "MUI2.nsh"
  !include "nsDialogs.nsh"
  !include "WordFunc.nsh"
  !insertmacro StrFilter

;--------------------------------
;General

  ;Variables
  Var dbrootpasspwd
  Var dbrootpass
  Var dbrootpassconfirmpwd
  Var dbrootpassconfirm
  Var dbrcsuserpass
  Var adminpasspwd
  Var adminpass
  Var adminpassconfirmpwd
  Var adminpassconfirm

  ;Name and file
  Name "RCSDB"
  OutFile "RCSDB.exe"

  ;Default installation folder
  InstallDir "C:\RCSDB\"

  ShowInstDetails "show"

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING
  !define MUI_WELCOMEFINISHPAGE_BITMAP "HT.bmp"
  !define MUI_WELCOMEFINISHPAGE_BITMAP_NOSTRETCH

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_WELCOME
  Page custom FuncConfigureUsers FuncConfigureUsersLeave
  !insertmacro MUI_PAGE_INSTFILES

;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "Install Section" SecInstall

  SetOutPath "$INSTDIR"

  File /r "..\"

SectionEnd

Section "Setup Section" SecSetup

  nsExec::ExecToLog '"$INSTDIR\apache\bin\openssl" rand -base64 -out "$INSTDIR\setup\rcspass.tmp" 12'

  FileOpen $0 "$INSTDIR\setup\rcspass.tmp" r
  FileRead $0 $dbrcsuserpass 16
  FileClose $0
  Delete "$INSTDIR\setup\rcspass.tmp"

  WriteINIStr "$INSTDIR\apache\htdocs\etc\RCSDB.ini" "dbdata" "host" "localhost"
  WriteINIStr "$INSTDIR\apache\htdocs\etc\RCSDB.ini" "dbdata" "user" "rcsuser"
  WriteINIStr "$INSTDIR\apache\htdocs\etc\RCSDB.ini" "dbdata" "pass" "$dbrcsuserpass"
  WriteINIStr "$INSTDIR\apache\htdocs\etc\RCSDB.ini" "dbdata" "db"   "rcs"

  DetailPrint ""
  DetailPrint "Executing install script.."

  nsExec::ExecToLog '"$INSTDIR\setup\RCSDB-install.bat" "$adminpass" "$dbrootpass" "$dbrcsuserpass"'

SectionEnd

;--------------------------------
;Installer Functions

Function FuncConfigureUsers

  !insertmacro MUI_HEADER_TEXT "Configuration settings" "Please enter configuration settings."

  nsDialogs::Create /NOUNLOAD 1018

  ${NSD_CreateLabel} 0 5u 100% 10u "Password for user 'admin':"
  ${NSD_CreateLabel} 5u 22u 40u 10u "Password:"
  ${NSD_CreatePassword} 50u 20u 200u 12u ""
  Pop $adminpasspwd
  ${NSD_CreateLabel} 5u 37u 40u 10u "Confirm:"
  ${NSD_CreatePassword} 50u 35u 200u 12u ""
  Pop $adminpassconfirmpwd

  ${NSD_CreateHLine} 0 60u 100% 1u ""

  ${NSD_CreateLabel} 0 75u 100% 10u "Database root password (for system administration purpose only):"
  ${NSD_CreateLabel} 5u 92u 40u 10u "Password:"
  ${NSD_CreatePassword} 50u 90u 200u 12u ""
  Pop $dbrootpasspwd
  ${NSD_CreateLabel} 5u 107u 40u 10u "Confirm:"
  ${NSD_CreatePassword} 50u 105u 200u 12u ""
  Pop $dbrootpassconfirmpwd

  nsDialogs::Show

FunctionEnd

Function FuncConfigureUsersLeave

  ${NSD_GetText} $adminpasspwd $adminpass
  ${NSD_GetText} $adminpassconfirmpwd $adminpassconfirm

  StrCmp $adminpass "" 0 +3
    MessageBox MB_ICONSTOP "Password cannot be empty"
    Abort

  StrCmp $adminpass $adminpassconfirm +3 0
    MessageBox MB_ICONSTOP "Password mismatch"
    Abort

  ${StrFilter} $adminpass "12" "" "" $adminpassconfirm
  StrCmp $adminpass $adminpassconfirm +3 0
    MessageBox MB_ICONSTOP "Password can only contains alphanumeric characters"
    Abort

  ${NSD_GetText} $dbrootpasspwd $dbrootpass
  ${NSD_GetText} $dbrootpassconfirmpwd $dbrootpassconfirm

  StrCmp $dbrootpass "" 0 +3
    MessageBox MB_ICONSTOP "Password cannot be empty"
    Abort

  StrCmp $dbrootpass $dbrootpassconfirm +3 0
    MessageBox MB_ICONSTOP "Password mismatch"
    Abort

  ${StrFilter} $dbrootpass "12" "" "" $dbrootpassconfirm
  StrCmp $dbrootpass $dbrootpassconfirm +3 0
    MessageBox MB_ICONSTOP "Password can only contains alphanumeric characters"
    Abort

  Return

FunctionEnd