<?php

//////////
///
///   backdoor.inc.php
///
//////////
///
///   backdoor_add($backdoor, $desc, $key, $version, $activity)
///   backdoor_mod($backdoor, $desc, $key, $version, $activity)
///   backdoor_del($backdoor)
///   backdoor_get($backdoor)
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & (AL_ADMN | AL_TECH)) {
   $dm['backdoor.add']['function'] = 'backdoor_add';
//   $dm['backdoor.add']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                  $xmlrpcString,     // $backdoor
//                                                  $xmlrpcString,     // $desc
//                                                  $xmlrpcString,     // $key
//                                                  $xmlrpcInt,        // $version
//                                                  $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_TECH)) {
   $dm['backdoor.mod']['function'] = 'backdoor_mod';
//   $dm['backdoor.mod']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                  $xmlrpcString,     // $backdoor
//                                                  $xmlrpcString,     // $desc
//                                                  $xmlrpcString,     // $key
//                                                  $xmlrpcInt,        // $version
//                                                  $xmlrpcString));   // $activity
}

if($al & (AL_ADMN | AL_TECH)) {
   $dm['backdoor.del']['function'] = 'backdoor_del';
//   $dm['backdoor.del']['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                  $xmlrpcString));   // $backdoor
}

if($al & (AL_ADMN | AL_TECH)) {
   $dm['backdoor.get']['function'] = 'backdoor_get';
//   $dm['backdoor.get']['signature'] = array(array($xmlrpcArray,
//                                                  $xmlrpcString));   // $backdoor
}

if($al & (AL_ADMN | AL_VIEW)) {
   $dm['backdoor.stat']['function'] = 'backdoor_stat';
//   $dm['backdoor.stat']['signature'] = array(array($xmlrpcArray,
//                                                 $xmlrpcArray));    // $backdoorarray
}



/***************\
*   FUNCTIONS   *
\***************/

function backdoor_add($backdoor, $desc, $key, $version, $activity)
{
   $err_map[1062] = $GLOBALS['err_backdoor']['exists'];
   $err_map[1452] = $GLOBALS['err_backdoor']['invactivity'];

   $ret = db_escape(array(&$backdoor,
                          &$desc,
                          &$key,
                          &$version,
                          &$activity));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = trace('backdoor.add', $backdoor);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "INSERT INTO `backdoor` (`backdoor`, ";
   $sql .=                         "`desc`, ";
   $sql .=                         "`key`, ";
   $sql .=                         "`version`, ";
   $sql .=                         "`target_id`) ";
   $sql .= "VALUES ('$backdoor', ";
   $sql .=         "'$desc', ";
   $sql .=         "'$key', ";
   $sql .=         "'$version', ";
   $sql .=         "'1')"; // forza l'associazione a MainTarget

   return db_query($sql, $err_map);
}

function backdoor_mod($backdoor, $desc, $key, $version, $activity)
{
   $err_map[1452] = $GLOBALS['err_backdoor']['invactivity'];

   $ret = db_escape(array(&$backdoor,
                          &$desc,
                          &$key,
                          &$version,
                          &$activity));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "UPDATE `backdoor` ";
   $sql .= "SET `desc` = '$desc', ";
   $sql .=     "`key` = '$key', ";
   $sql .=     "`version` = '$version', ";
   $sql .=     "`target_id` = '1' ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   return db_query($sql, $err_map);
}

function backdoor_del($backdoor)
{
   $ret = db_escape(array(&$backdoor));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = trace('backdoor.del', $backdoor);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "DELETE FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   return db_query($sql);
}

function backdoor_get($backdoor)
{
   $ret = db_escape(array(&$backdoor));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor`, ";
   $sql .=        "`desc`, ";
   $sql .=        "`key`, ";
   $sql .=        "`version`, ";
   $sql .=        "'MainActivity' AS `activity` ";
   $sql .= "FROM `backdoor`";
   $sql .= ($backdoor ? " WHERE `backdoor` = '$backdoor'" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_backdoor']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->version, 'integer');
      if(is_null($r->activity)) {
         $r->activity = '';
      }
   }
 
   return $ret;
}

function backdoor_stat($backdoorarray)
{
   $ret = db_escape(array(&$backdoorarray));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($backdoorarray);

   if(is_object($ret)) {
      return $ret;
   }

   $tmp = array();

   foreach($backdoorarray as $backdoor) {
      $sql  = "SELECT `backdoor`, ";
      $sql .=        "`remoteip`, ";
      $sql .=        "`received` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE `backdoor` = '$backdoor' ";
      $sql .= "ORDER BY `received` DESC ";
      $sql .= "LIMIT 1";

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      } else if($ret === false) {
         continue;
      }

      foreach($ret as &$r) {
         xmlrpc_set_type($r->received, 'datetime');
      }

      $tmp = array_merge($tmp, $ret);
   }
   
   if(!count($tmp)) {
      return $GLOBALS['err_backdoor']['empty'];
   }

   return $tmp;
}

?>
